-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Written by Kimberly L. Tripp, SQLskills.com
-- All Rights Reserved.
-- 
-- For more scripts, sample code and additional training resources,
-- go to http://www.SQLskills.com
--	Immerse yourself in SQL Server
--
-- Disclaimer - Thoroughly test this script, execute at your own risk.
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

USE TSQLTutorJoins
go

CREATE TABLE dbo.EmployeeSelfJoin
(
	EmpID	int	NOT NULL	IDENTITY
			CONSTRAINT EmployeeSelfJoinPK
				PRIMARY KEY,
	FName	varchar(10)	NOT NULL,
	LName	varchar(10)	NOT NULL,
	MgrID	int	NULL
			CONSTRAINT EmployeeSelfJoinMgrIDEmpIDFK
				FOREIGN KEY
					REFERENCES dbo.EmployeeSelfJoin(EmpID)
)
go

INSERT dbo.EmployeeSelfJoin (FName, LName, MgrID)
	VALUES ('Bob', 'Smith', NULL) -- No Manager
go
SELECT @@IDENTITY -- Get the ID of Bob Smith
SELECT * FROM dbo.EmployeeSelfJoin  -- Just to confirm
go

INSERT dbo.EmployeeSelfJoin
	VALUES ('Kimberly', 'Tripp', @@IDENTITY) -- lasts for this SESSION till reset by another identity value insert
go

SELECT * FROM dbo.EmployeeSelfJoin  -- Does the data look right?!
go

SELECT E.FName + ' ' + E.LName AS 'Employee Name',
	M.FName + ' ' + M.LName AS 'Manager Name'  
FROM dbo.EmployeeSelfJoin AS E
	INNER JOIN dbo.EmployeeSelfJoin AS M 
		ON E.MgrID = M.EmpID
-- This will not return Bob Smith - as an employee.
go

SELECT E.FName + ' ' + E.LName AS 'Employee Name',
	M.FName + ' ' + M.LName AS 'Manager Name'  
FROM dbo.EmployeeSelfJoin AS E
	LEFT OUTER JOIN dbo.EmployeeSelfJoin AS M 
		ON E.MgrID = M.EmpID
go
SELECT E.FName + ' ' + E.LName AS 'Employee Name',
		CASE
			WHEN M.LName IS NULL THEN 'Self Managing'
			ELSE M.FName + ' ' + M.LName
		END 
			AS 'Manager Name'    --CASE
FROM dbo.EmployeeSelfJoin AS E
	LEFT OUTER JOIN dbo.EmployeeSelfJoin AS M 
		ON E.MgrID = M.EmpID
go
--This will return ALL employees including Bob Smith.

